﻿using Infragistics.Documents.Excel;
using Infragistics.Win.UltraWinGrid.ExcelExport;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;


namespace Case179466_Excel
{
    public partial class Form1 : Form
    {
        public string newSheetName = "newsheet";
        private Worksheet oWorkSheet;


        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
               
            //doing some manual formating in events and adding export data from filled Ultragrid to newly added worksheet 
         
            this.ultraGridExcelExporter1.HeaderRowExporting += new Infragistics.Win.UltraWinGrid.ExcelExport.HeaderRowExportingEventHandler(HeaderRowExporting);
            ultraGridExcelExporter1.SummaryRowExporting += new Infragistics.Win.UltraWinGrid.ExcelExport.SummaryRowExportingEventHandler(SummaryRowExporting);
            ultraGridExcelExporter1.InitializeColumn += new Infragistics.Win.UltraWinGrid.ExcelExport.InitializeColumnEventHandler(InitializeColumn);
            ultraGridExcelExporter1.RowExporting += new Infragistics.Win.UltraWinGrid.ExcelExport.RowExportingEventHandler(RowExporting);
            ultraGridExcelExporter1.BandSpacing = Infragistics.Win.UltraWinGrid.ExcelExport.BandSpacing.None;
            ultraGridExcelExporter1.InitializeSummary += new EventHandler<InitializeSummaryEventArgs>(InitializeSum);
            ultraGridExcelExporter1.SummaryCellExported += new Infragistics.Win.UltraWinGrid.ExcelExport.SummaryCellExportedEventHandler(ugrdReport_SummaryCellExported);
            ultraGridExcelExporter1.ExportFormulas = false;



        }

        private void InitializeSum(object sender, InitializeSummaryEventArgs e)
        {
            e.ExcelFormatStr = e.Summary.SourceColumn.Format;
        }

        private void ugrdReport_SummaryCellExported(object sender, SummaryCellExportedEventArgs e)
        {

        }

        private void RowExporting(object sender, RowExportingEventArgs e)
        {

        }

        private void InitializeColumn(object sender, InitializeColumnEventArgs e)
        {
            e.ExcelFormatStr = e.Column.Format;
        }

        private void SummaryRowExporting(object sender, SummaryRowExportingEventArgs e)
        {

        }

        private void HeaderRowExporting(object sender, HeaderRowExportingEventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
         WorkbookLoadOptions option = new WorkbookLoadOptions("pass1");

            Infragistics.Documents.Excel.Workbook workbook =
            Infragistics.Documents.Excel.Workbook.Load(Application.StartupPath + "\\MyWorkBook.xls", option);

            if (workbook.IsProtected) workbook.Unprotect("pass1");

            //removing sheet by name if exists and then adding new one with same name
            if (workbook.Worksheets.ToList().Select(x => x.Name == newSheetName).Count() > 0)
            {
                for (int i = 0; i < workbook.Worksheets.Count; i++)
                {
                    if (workbook.Worksheets[i].Name == newSheetName)
                    {
                        workbook.Worksheets.RemoveAt(i);
                    }
                }
            }

            oWorkSheet = workbook.Worksheets.Add("newsheet");


            ultraGridExcelExporter1.Export(ultraGrid1, oWorkSheet, 4, 0);


            //setting up file write protection passowrs
            workbook.SetFileWriteProtectionPassword("pass1");

            //And saving 
            workbook.Save(Application.StartupPath + "\\MyWorkBook.xls");

        }




    }
}
